/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

typedef long long ll;

const int MAX=16;

int n, m, s, cost[MAX][MAX];
int cnt[MAX], stck[MAX];
ll k;
vector <int> cost_start[MAX];
vector <int> sum;
map<int, int> fuck;

int count_cost(vector <short> & v, int pos)
{
    int ret=0;
    for(int i=0; i<v.size(); ++i)
        ret+=cost[pos+i][v[i]];
    return ret;
}

void brute(int step, int start, int finish)
{
    if(step==s)
    {
        sum[cnt[s]]=finish;
    }
    if(step)
    {
        if(step==m-s)
            ++fuck[start];
        cost_start[step][cnt[step]++]=start;
    }
    if(step<m-s)
    {
        for(int i=0; i<n; ++i)
        {
            stck[step]=i;
            brute(step+1, start+cost[step][i], finish+cost[m-s+step][i]);
        }
    }
}

ll h(int c)
{
    return lower_bound(sum.begin(), sum.end(), c)-sum.begin();
}

ll f(int c)
{
    ll ret=0;
    for(map<int, int>::iterator it=fuck.begin(); it!=fuck.end(); ++it)
        ret+=it->second*(sum.size()-h(c-it->first+1));
    return ret;
}

ll sukasukasuka(int step, int max_step, int now, int pos, int c)
{
    ll ret=0;
    if(step==max_step)
    {
        ret=h(c-now+1) -
            h(c-now);
    }
    if(step<max_step)
    {
        for(int i=0; i<n; ++i)
        {
            stck[step]=i;
            ret+=sukasukasuka(step+1, max_step, now+cost[pos+step][i], pos, c);
        }
    }
    return ret;
}

ll blyat(int step, int max_step, int now, int pos, int c)
{
    ll ret=0;
    if(step==max_step)
    {
        ret=(now==c);
    }
    if(step<max_step)
    {
        for(int i=0; i<n; ++i)
        {
            stck[step]=i;
            ret+=blyat(step+1, max_step, now+cost[pos+step][i], pos, c);
        }
    }
    return ret;
}

ll g(int c, vector <short> & v)
{
    ll ret=0;
    ll tmp=count_cost(v, 0);
    if(v.size()<m-s)
    {
        /*
        for(int i=0; i<all[m-s-v.size()].size(); ++i)
        {
            ret+=h(c-tmp-count_cost(all[m-s-v.size()][i], v.size())+1) -
                 h(c-tmp-count_cost(all[m-s-v.size()][i], v.size()));
        }
        */
        ret=sukasukasuka(0, m-s-v.size(), 0, v.size(), c-tmp);
    }
    else if(v.size()<m)
    {
        /*
        for(int i=0; i<all[m-v.size()].size(); ++i)
            ret+=((tmp+count_cost(all[m-v.size()][i], v.size()))==c);
        */
        ret+=blyat(0, m-v.size(), 0, v.size(), c-tmp);
    }
    else ret=(tmp==c);
    return ret;
}

int main()
{
    ios::sync_with_stdio(0);
    ifstream cin("aliens.in");
    ofstream cout("aliens.out");
    int mx=0;
    cin >> n >> m >> k;
    for(int i=0; i<m; ++i)
        for(int j=0; j<n; ++j)
            cin >> cost[i][j], mx=max(cost[i][j], mx);
    s=m>>1;
    int power=n;
    for(int i=1; i<=m-s; ++i)
    {
        cost_start[i].resize(power);
        if(i==s) sum.resize(power);
        power*=n;
    }
    brute(0, 0, 0);
    sort(sum.begin(), sum.end());
    ll l=0, r=mx*m+1;
    while(l<r-1)
    {
        ll m=(l+r)>>1;
        if(f(m)<k) r=m;
        else l=m;
    }
    ll same=k-f(r), num=0;
    vector <short> ans, vec;
    for(int i=0; i<m; ++i)
    {
        vec.push_back(0);
        for(int j=0; j<n; ++j)
        {
            vec[i]=j;
            ll tmp=g(r, vec);
            if(num+tmp<same) num+=tmp;
            else
            {
                ans.push_back(j);
                break;
            }
        }
    }
    for(int i=0; i<m; ++i)
        cout << char(ans[i]+'a');
    cout << endl;
    return 0;
}
