#include <iostream>
#include <string>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>

#define inf 100000000

using namespace std;

int a, b, c, d, i, j, k, n, m, what, half, l;
int p[22][22], m_f[1 << 20], m_s[1 << 20], *mem, s1, s2, ans[22];
long long q;

 void rec(int v, int cur = 0) {
    if(v >= l) {
        mem[k++] = cur;
        return;
    }

    for(i = 0; i < n; i++)
        rec(v + 1, cur + p[v][i]);
}

 long long cnt(int val) {
    a = s2 - 1;
    long long ans = 0;

    for(i = 0; i < s1; i++) {
        while(a >= 0 && ((m_f[i] + m_s[a]) > val)) a--;
        if(a < 0) break;
        ans += a + 1;
    }
    return ans;
}

 void fnd_e_t(int v, int cur = 0) {
    if(cur > what) return;
    if(v >= m) {
        if(cur < what) return;
        --q;
        if(q >= 0) return;

        for(i = 0; i < m; i++) printf("%c", ans[i] + 'a');
        printf("\n");
        exit(0);
    }

    for(i = n - 1; i >= 0; i--) {
        ans[v] = i;
        fnd_e_t(v + 1, cur + p[v][i]);
    }
}

 void fnd_e(int v, int cur = 0) {
    if(v >= half) {
        int tot = upper_bound(mem, mem + k, what - cur) - lower_bound(mem, mem + k, what - cur);
        if(tot <= q) {
            q -= tot;
            return;
        }
        what -= cur;
        fnd_e_t(half);
        return;
    }
    for(i = n - 1; i >= 0; i--) {
        ans[v] = i;
        fnd_e(v + 1, cur + p[v][i]);
    }
}

 void fnd_w(int val) {
    mem = m_s;
    k = s2;
    what = val;
    fnd_e(0);
}

int main() {
    freopen("aliens.in", "r", stdin);
    freopen("aliens.out", "w", stdout);

    cin >> n >> m >> q;

    long long tot = 1;
    for(i = 0; i < m; i++)
        tot *= n;

    q = tot - q;
    for(i = 0; i < m; i++)
        for(j = 0; j < n; j++)
            cin >> p[i][j];

    half = m / 2;
    mem = m_s; l = m; k = 0;
    rec(half);
    s2 = k;

    mem = m_f, l = half; k = 0;
    rec(0);
    s1 = k;

    sort(m_f, m_f + s1);
    sort(m_s, m_s + s2);


    int l = 0, r = 2 * inf;
    while((r - l) > 1) {
        int tt = (r + l) / 2;
        if(cnt(tt) <= q) l = tt;
        else r = tt;
    }

    q -= cnt(l);
    fnd_w(r);
}
