#include <iostream>
#include <string>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>

#define inf 100000000
#define maxn 100000
#define mod 1000000007

using namespace std;

int fr[maxn], gr[maxn], fl[maxn], gl[maxn], fi[maxn], fi_c[maxn];
int powa[maxn] = {1, };
const int a = 35521, m = 28768;

inline void gen_r(int sz) {
    fr[1] = gr[1] = 0;
    for(int i = 1; i < sz; i++) {
        fr[i] = (fr[i - 1] + (fi[i] - fi[i - 1]) * powa[i - 1]) % m;
        gr[i] = (fi[i] - fi[i - 1] + gr[i - 1] * a) % m;
    }
}

inline void gen_l(int sz) {
    fl[0] = gl[0] = 0;
    for(int i = 1; i < sz; i++) {
        fl[i] = (fl[i - 1] + (fi_c[i - 1] - fi_c[i]) * powa[i - 1]) % m;
        gl[i] = (fi_c[i - 1] - fi_c[i] + gl[i - 1] * a) % m;
    }
}

inline bool cheak(int pos, int sz) {
    for(int i = 1; i < pos; i++)
        if((fi[i] - fi[i - 1]) != (fi[pos - i] - fi[pos - i - 1]))
            return false;

    for(int i = pos + 1; i < sz; i++)
        if((fi[i] - fi[i - 1]) != (fi[sz + pos - i] - fi[sz + pos - i - 1]))
            return false;

    return true;
}


int main() {
    freopen("symmetry.in", "r", stdin);
    freopen("symmetry.out", "w", stdout);

    for(int i = 1; i < maxn; i++)
        powa[i] = (powa[i - 1] * a) % m;
    int test;
    scanf("%d", &test);

    for(int _i = 0; _i < test; _i++) {
        int s;
        scanf("%d", &s);
        for(int i = 0; i < s; i++) {
            scanf("%d", &fi[i]);
            fi_c[s - i - 1] = fi[i];
        }
        gen_r(s); gen_l(s);
        for(int i = 0; i < s - 1; i++)
            if(fr[i] == gr[i])
                if(fl[s - i - 2] == gl[s - i - 2])
                    if(cheak(i + 1, s)) {
                        printf("%d\n", i + 1);
                        goto nex;
                    }
        printf("0\n");
        nex:;
    }
    return 0;
}
